;; Types "PLF" pour developpements harmoniques, cf. Jean-Claude Risset, etc.
(defun plf1 (fond nbr &optional (sup 10) &aux (lifreq nil))
	(dotimes (i nbr lifreq)
		(setq lifreq (cons (* fond (1+ (random sup))) lifreq))))

(defun plf2 (fond nbr &optional (sup 10) &aux (lifreq nil) (frequence 0))
	(do ()
		((= nbr (list-length lifreq)) lifreq)
			(setq frequence (* fond (1+ (random sup))))
			(when (not (equal frequence (car lifreq)))
				(setq lifreq (cons frequence lifreq)))))

;; Cf. ~dlo/.clinit.cl.
;; A partir de 2 points (x1,y1) et (x2,y2), donne 2 values : les coefficients
;; a et b de la fonction lineaire y=ax+b passant par ces deux points.
(defun y=ax+b (x1 x2 y1 y2)
  (let ((a (float (/ (- y2 y1) (- x2 x1)))))
    (values a (- y2 (* x2 a)))))

;;exemple	(setq mesfreqs (plf2 440.0 15 7))
;;			(plf3 mesfreqs -10 -30) --> liste de dB
(defun plf3 (lifreq dBfmin dBfmax &aux lidB fmin fmax)
	(setq fmin (apply #'min lifreq))
	(setq fmax (apply #'max lifreq))
	(multiple-value-bind (a b) (y=ax+b fmin fmax dBfmin dBfmax)
		(dolist (lafreq lifreq (reverse lidB))
			(setq lidB (cons (+ (* a lafreq) b) lidB)))))
