;;   Exemples simples de lambda listes, cf. [CLtL2:76-81]. Pour les deux
;; premiers, un quivalent "nomm" est donn avec defun, cf. [CLtL2:84].
;; - lambda-liste
;; - argument(s)
;$   Einfache Beispiele fr lambda-Listen, vgl. [CLtL2:76-81]. Fr die ersten
;$ beiden wird ein "benanntes" Equivalent mit defun gegeben, vgl. [CLtL2:84].
;$ - lambda-Liste
;$ - Argument(e)                                                      [d..H.B.]
;+   Simple examples of lambda-lists, cf. [CLtL2:76-81]. For the two first, a
;+ "named" equivalent is given with defun, cf. [CLtL2:84].
;+ - lambda-list
;+ - argument(s)

;;   1 : arguments obligatoires
;$   1: obligatorische Argumente
;+   1: compulsory arguments

((lambda (a b) (+ a (* b 3))) 4 5)

(defun toto1 (a b)
  (+ a (* b 3)))
(toto1 4 5)

;;   2 : arguments optionnels
;$   2: optionale Argumente
;+   2: optional arguments

((lambda (a &optional (b 2)) (+ a (* b 3))) 4 5)
((lambda (a &optional (b 2)) (+ a (* b 3))) 4  )

(defun toto2 (a &optional (b 2))
  (+ a (* b 3)))
(toto2 4 5)
(toto2 4  )

;;   3 : mots-clef
;$   3: Schlsselwrter
;+   3: key-words

((lambda (a b &key c d) (list a b c d)) 1 2     )
((lambda (a b &key c d) (list a b c d)) 1 2 :c 6)
((lambda (a b &key c d) (list a b c d)) 1 2 :d 8)

(defun toto3 (a b &key c d)
  (list a b c d))
(toto3 1 2)
(toto3 1 2 :c 6)
(toto3 1 2 :d 8)

;;   4 : mot-clef "augument(s) restant(s)" &rest -- exemples de mon cru.
;; Le dernier prsume une dfinition de l'argument d'appel <a>.
;$   4: "restliche(s) Argument(e)"-Schlsselwort &rest -- Beispiele von mir.
;$ Das letzte setzt voraus, dass das Aufrufargument <a> definiert ist.
;+   4: &rest "remaining argument(s)" key-word--examples of my own. The last one
;+ presumes a definition of the calling argument <a>.

((lambda (x &rest y) (list x y)) 10                    )
((lambda (x &rest y) (list x y)) 10 99.99              )
((lambda (x &rest y) (list x y)) 10 99.99 12 a 33 'toto)

(defun toto4 (x &rest y)
  (list x y))
(toto4 10)
(toto4 10 99.99)
(toto4 10 99.99 12 a 33 'toto)

