;-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;-
;- Fichier ped.10.cl, NON DISTRIBU : pour servir d'exemples
;-                     UTILISER MANUELLEMENT...
;-
;- TAUX d'CHANTILLONNAGE = 32000 (historique... et plus rond que 44100)
;-
;-;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;-- Ce fichier peut tre charg. Il comporte, dans ses dernires lignes, des
;-- exemple  valuer manuellement.
;-- Version LispWorks CAPI, 05.2009

;- TiBkG4 : la fentre maximale est :view-size #@(1150 720) (horiz. - verti.)
;- MacBookPro 2009 : la fentre maximale est 1920 x 1200 (horiz. - verti.)

;-   Variables et fonction pour sortie graphique sur une rsolution verticale de
;- 80 doubles pixels & largeur 750 doubles pixels. Il faut 24 pixels de plus
;- verticalement pour CAPI (sans doute  cause de la barre de titre).

(defparameter DimFen '(1500 . 184))
(defparameter *fen*
  (capi::contain
   (make-instance 'capi::output-pane)
                  :best-width (car DimFen)
                  :best-height (cdr DimFen)
                  :title (string (gensym "Oscilloscope-"))))

;- ATTENTION LispWorks : NE PAS VALUER LA FONCTION
;-    CONTINOSC
;- NI LA MACRO-FONCTION
;-    G
;- qui commandent les appels graphiques 
;-    ligneGR ou lignePR
;- DANS UNE FENTRE EDITOR ==> ON PERD LA MAIN !
;- ==> COPIER LES LIGNES DSIRES DANS LISTENER !!!
;- ==> VALUER DANS LISTENER !!!

;- N.B. : - cliquer bouton Break pour figer le dfilement
;-        - :c 1 ou bouton Continue pour reprendre
;-        - q pour arrter dfinitivement

(defparameter abscisse 0)

(defun ligneGR (num &key (max 79) &aux indx)
;(dbg num)
  ;(setq indx (round (+ (* (/ max 2.0) num) (/ 79.0 2.0))))
  (setq indx (round (+ (* (+ num 1.0) (/ max 2.0)) (/ (- 79.0 max) 2.0))))
;(dbg indx)
  (if (> indx 79) (incf indx (- 79))
      (when (minusp indx) (incf indx 79)))
;(dbg indx)
  (capi::apply-in-pane-process *fen*;effacer le pixel prcdent  cette abscisse
                               'gp::draw-rectangle *fen*      ;et les 9 suivants
                               abscisse 0 20 (cdr DimFen)
                               :foreground :white
                               :filled t)
  (capi::apply-in-pane-process *fen*    ;dessiner nouveau pixel  cette abscisse
                               'gp::draw-rectangle *fen*
                               abscisse (* 2 indx) 2 2
                               :foreground :black
                               :filled t)
  ;LispWorks : 0.001 sec. = timeout minimum possible = trop lent
  ;(mp::process-wait-with-timeout "pour ralentir...secs" 0.001))   ;<--LispWorks
  (dotimes (n 500) (eval t)))            ;perte de temps... <-- RGLAGE VITESSE

(defmacro continosc (programme)
  (setq abscisse 0)
  (capi::apply-in-pane-process *fen*                         ;effacer la fentre
                               'gp::draw-rectangle *fen*
                               0 0 (car DimFen) (cdr DimFen)
                               :foreground :white
                               :filled t)
  (format *debug-io* "~&Taper quelque chose, par ex. <=>, pour ~
                     commencer, et <q> pour finir.~%")
  (read-char *debug-io* nil t t)
  (terpri)
  `(loop
     ,programme
     (setq abscisse (mod (+ abscisse 2) (car DimFen)))
     (when (equal #\q (read-char-no-hang *debug-io* nil t t))
       (return 'ok))))

;- Cette fonction imprime une * (ou un autre caractre)  la position
;- horizontale donne par l'argument d'appel <num>, dans [-1,1]. Par exemple :
;-    (ligne -1.0 :max 46) => "*                                           "
;-    (ligne  0.0 :max 46) => "                    *                       "
;-    (ligne  1.0 :max 46) => "                                           *"
;- La valeur par dfaut 79 du mot-clef :max est prvue pour une fentre de 80
;- caractres de largeur.

;Premire dfinition : deux inconvnients. [1] Les lignes courtes (avec "*"
;plutt  gauche) sont imprimes plus vite que les longues (avec "*" plutt
; droite) => impression irrgulire des fonctions chantillonnes...
;[2] Plus lente que la version ci-dessous.
;(defun lignePR (num &key (max 79))
;  (dotimes (x (round (+ (* (+ num 1.0) (/ max 2.0)) (/ (- 79.0 max) 2.0)))
;              (format t "*~%"))
;    (format t " ")))
;Deuxime dfinition, mieux que ci-dessus.
(defparameter chaine (make-string 80 :initial-element #\ ))
(defparameter bullules (make-array 12 :initial-contents '(#\ #\. #\o #\O #\* #\ #\o #\O #\0 #\* #\@ #\:)))
(defun lignePR (num &key (max 79) (bulles nil) &aux indx)
  (setq indx (round (+ (* (+ num 1.0) (/ max 2.0)) (/ (- 79.0 max) 2.0))))
  (if (> indx 79) (incf indx -79)
      (when (minusp indx) (incf indx 79)))
  (setf (aref chaine 40) #\)
  (setf (aref chaine indx) (if bulles (aref bullules (random 12)) #\*))
  (format t "~A~%" chaine)
  (mp::process-wait-with-timeout "pour ralentir...secs" 0.003)     ;<--LispWorks
  ;(dotimes (n 10000) (eval t))           ;perte de temps... <-- RGLAGE VITESSE
  (setf (aref chaine indx) #\ ) 'ok)

;- Bon pour exemples de trigo, mais surtout du principe d'chantillonnage...
;- Exemples suivants avec (sin <radians>), mise en oeuvre sous la forme
;- (sin (incf <angle> <pas>)), ou (sin (incf <angle> (freq <Hz>))).
;- N.B. : 360 degrs = 2*pi radians.

;- Calcul des <pas> angulaires  partir d'une frquence <f>, par rapport  un
;- taux d'chantillonnage de 32000 ch./sec. (plus rond que 44100...).
(defun freq (f)
  (/ (* 2.0 pi f) 32000.0))
;- N.B. : priode, en chantillons = (/ (* 2 pi) <pasN>)
;-                                 = (/ (* 2 pi) (freq <Hz>))

;- N.B. : cliquer pour figer le dfilement.

;- Utilisation type, version complte et laborieuse :
(defparameter angle (- (freq 1230)))                 ;=> environ 26 ch./priode
;    (continosc (ligneGR (sin (incf angle (freq  111)))))
; ou   (continu (lignePR (sin (incf angle (freq  111)))))
;    (continosc (ligneGR (sin (incf angle (freq  111))) :max 40))
;    (continosc (ligneGR (sin (incf angle (freq  111))) :max 20))
;    (continosc (ligneGR (sin (incf angle (freq  111))) :max 10))
;    (continosc (ligneGR (sin (incf angle (freq  111))) :max  5))
;    (continosc (ligneGR (sin (incf angle (freq  218)))))
;    (continosc (ligneGR (sin (incf angle (freq  218))) :max 40))
;    (continosc (ligneGR (sin (incf angle (freq  630)))))
;    (continosc (ligneGR (sin (incf angle (freq  630))) :max 40))
; ou   (continu (lignePR (sin (incf angle (freq  630))) :max 40))
;    (continosc (ligneGR (sin (incf angle (freq 1230)))))
;    (continosc (ligneGR (sin (incf angle (freq 1230))) :max 40))
;    (continosc (ligneGR (sin (incf angle (freq 1230))) :max  5))
;    (continosc (ligneGR (sin (incf angle (freq 1230))) :max  2))

;- Ou encore, avec modulation d'amplitude ou ring-modulation :
(defparameter pas1 (freq 100))                    ;modulante lente
(defparameter pas2 (freq 1140))                   ;porteuse plus rapide
(defparameter ang1 (- pas1))
(defparameter ang2 (- pas2))
;2 sinus multiplis
; (continosc(ligneGR(* (sin (incf ang1 pas1))(sin (incf ang2 pas2)))))


;- On peut redfinir ensuite des valeurs, par exemple <pas1>, et recommencer
;- avec de nouveaux appels de (continu... ci-dessus :
;    (defparameter pas1 (freq 20))       ;modulante trs lente
;    (defparameter pas1 (freq 440))      ;    "    assez rapide
;    (defparameter pas1 (freq 2345))     ;    "    rapide
;    (defparameter pas1 (freq 5399))     ;    "    encore plus rapide

;- On peut aussi faire des exemples de sous-chantillonnage, repliement, etc.
;- Formule simplifie pour exemples du principe d'chantillonnage, avec
;- macro fonction g :
;-    => g <freq> &optional (maxi 40), et c'est tout !!
(defmacro g (f &optional (maxi 79))
  ;(setq chaine (make-string 80 :initial-element #\ ))
  `(continosc (ligneGR (sin (incf angle (freq ,f))) :max ,maxi)))
;- ATTENTION : affichages trompeurs quand on est plutt prs de 16000 (moiti
;- du taux d'chantillonnage) : effets de dphasages divers entre la frquence
;-  reprsenter et celle du taux d'chantillonnage. Mais a marche.
;    (g    150)
;    (g    220)
;    (g    350)
;    (g    750)
;    (g   1500)
;    (g  15000)                  ;un peu plus de 2 ch./pr.
;    (g  17000)                  ;alias
;    (g -15000)                  ;alias
;- ou
;    (g 16000)                   ;2 ch./pr. : pas = pi
;    (g 32000)                   ;1 pr./ch. : pas = 2*pi
;    (g 32205)                   ;0.9968 ch./pr., pas = (2*pi)+0.04

;- 5 frquences "alias" : 1140, 30860, 33140, 62860, 65140...
;- Toutes frquences ngatives aussi...
;    (g  1140)                   ;1140 = Te/2 - 14860
;    (g -1140)                   ;la mme ngative...
;    (g 30860)                   ;Te/2 + 14860 = Te - 1140
;    (g 33140)                   ;Te + 1140
;    (g 62860)                   ;3*Te/2 + 14860
;    (g 65140)                   ;2*Te + 1140
;- etc...

;- Idem, exemples de dbordement, avec argument optionnel transmis au mot-clef
;- :max > 79 :
;    (g 220   8)                 ;amplitude -20dB
;    (g 220  40)                 ;amplitude  -6dB
;    (g 220  80)                 ;amplitude limite 0dB
;    (g 220  81)                 ;dbordement/clipping
;    (g 220  85)                 ;dbordement/overflow
;    (g 220  99)                 ;dbordement/overflow
;    (g 220 160)                 ;dbordement/overflow (+6dB)
;    (g 220 217)                 ;dbordement/overflow
;N.B. :  cause d'adresses hors bornes pour la primitive aref, dans la fonction
;ligneGR, ceci ne marche qu'avec max <= 238 = (3*79)+1.

;- Exemples mathmatiques aussi possibles avec (abs... (cos...
;- Idem, exemples avec des canons stochastiques :
(load (merge-pathnames "canons_tous.lisp" common-lisp::*path-stochastique*))
;    (continu (lignePR (gauss 0.0 0.15) :bulles t)) ;diffrents verres de champagne...
; ou         (continosc (ligneGR (gauss 0.0 0.15))) ;diffrents verres de champagne...
;    (continu (lignePR (gauss 0.0 0.33) :bulles t))
;    (continu (lignePR (plapla 0.0 0.15) :bulles t))
;    (continu (lignePR (corect -1.0 1.0) :bulles t));plutt Perrier (verre  fond plat)
;    (continu (lignePR (corect 0.1 0.6) :bulles t));plutt Perrier localis !
;    (continu (lignePR (beta 0.25 0.25) :bulles t));"1/2 verre" + bulles prs parois !
; ou         (continosc (ligneGR (beta 0.25 0.25)));"1/2 verre" + bulles prs parois !
;    (continu (lignePR (cobeta 0.125 0.125 -1.0 1.0) :bulles t)) ;plein verre idem.
; ou/vari  (continosc (ligneGR (cobeta 0.125 0.0125 -0.8 0.8))) ;plein verre idem.

;- Ex. exo.10 : -1 ^ & +1 v de fentre graphique
;-    (continosc (ligneGR (- (expon 5) 1)))    ; ^ > v            ; 2
;-    (continosc (ligneGR (- 1 (expon 5))))    ; ^ < v            ; 3
;-    (continosc (ligneGR (corect -1 1)))                         ; 1
;-    (continosc (ligneGR (gauss 0 0.3)))                         ; 6
;-    (continosc (ligneGR (plapla 0 0.1)))                        ; 7
;-    (continosc (ligneGR (- (linea 2) 1)))    ; ^ > v            ; 4
;-    (continosc (ligneGR (- 1 (linea 2))))    ; ^ < v            ; 5
;-    (continosc (ligneGR (cobeta 1/5 1/5 -1.0 1.0) ))            ; 8

;- Squences quasi-alatoires (cf. stoch.d/QuAlea)
;    (dolist (le (QuAleaCorput 10 -1 1 :permut t) 'ok) (lignePR le))
;    (dolist (le (QuAleaCorput 10 -1 1) 'ok) (lignePR le))
;    (dolist (le (QuAleaEq 10 -1 1) 'ok) (lignePR le))
;    (dolist (le (QuAleaEq 10 -1 1 :permut nil) 'ok) (lignePR le))
