;;; Ce fichier peut tre charg. Il comporte des exemple  valuer manuellement.
;;; Version LispWorks CAPI, 05.2009

;;   Exemples de ralisations de dessins fractals rcursifs en forme de "C" ou
;; de "Dragon" (cf. [Winston & Horn:60 sq.]). En outre : un "Crabe", une sorte
;; de "Vegetal", un "Triangle", une "Grappe" et une "Virgule", toujours  partir
;; de la structure de la fonction "Dragon", mais avec des gestions diffrentes
;; des inversions de sens.

;; TiBkG4 : la fentre maximale est :view-size #@(1150 720) (horiz. - verti.)
;; MacBookPro 2009 : la fentre maximale est 1920 x 1200 (horiz. - verti.)

;; LispWorks : un point est repsent par une paire pointe de coordonnes
;; (x . y)

;;   Utilisations type, avec dimensions de fentres appropries. L'origine de
;; tous les tracs est invariable  (100 . 100).
;; Mettre ventuellement lon_min  2.0 ou 3.0 pour allger :
;; (defparameter lon_min 2.0) ou (defparameter lon_min 3.0)
;; "C" :
;;   Construction graduelle,  valuer d'un coup, image par image -- les
;; fentres seront rparties cte  cte sur l'cran -- jusqu' lon_min minimale
;; = 1 pixel
;;  (progn (setq lon_min 130.0) (DesC 125 pis4 '(310 . 270))
;;         (setq lon_min  90.0) (DesC 125 pis4 '(310 . 270) '( 280 .  44))
;;         (setq lon_min  63.0) (DesC 125 pis4 '(310 . 270) '( 560 .  44))
;;         (setq lon_min  46.0) (DesC 125 pis4 '(310 . 270) '( 840 .  44))
;;         (setq lon_min  33.0) (DesC 125 pis4 '(310 . 270) '(1120 .  44))
;;         (setq lon_min  23.0) (DesC 125 pis4 '(310 . 270) '(  10 . 314))
;;         (setq lon_min  17.0) (DesC 125 pis4 '(310 . 270) '( 280 . 314))
;;         (setq lon_min  12.0) (DesC 125 pis4 '(310 . 270) '( 560 . 314))
;;         (setq lon_min   9.0) (DesC 125 pis4 '(310 . 270) '( 840 . 314))
;;         (setq lon_min   7.0) (DesC 125 pis4 '(310 . 270) '(1120 . 314))
;;         (setq lon_min   5.0) (DesC 125 pis4 '(310 . 270) '(  10 . 584))
;;         (setq lon_min   3.5) (DesC 125 pis4 '(310 . 270) '( 280 . 584))
;;         (setq lon_min   2.5) (DesC 125 pis4 '(310 . 270) '( 560 . 584))
;;         (setq lon_min   1.8) (DesC 125 pis4 '(310 . 270) '( 840 . 584))
;;         (setq lon_min   1.0) (DesC 125 pis4 '(310 . 270) '(1120 . 584)))
;;   Autres "C"...
;;       (DesC 115 0       '(310 . 310))
;;       (DesC 90 (- pis4) '(310 . 310))
;;       (DesC 200 0       '(350 . 450))
;; "Dragon" :
;;   Construction graduelle,  valuer d'un coup, image par image -- les
;; fentres seront rparties cte  cte sur l'cran -- jusqu' lon_min minimale
;; = 1 pixel
;;  (progn (setq lon_min 200.0) (DesDrag 125 pis4 '(310 . 310))
;;         (setq lon_min 100.0) (DesDrag 125 pis4 '(310 . 310) '( 280 .  44))
;;         (setq lon_min  70.0) (DesDrag 125 pis4 '(310 . 310) '( 560 .  44))
;;         (setq lon_min  50.0) (DesDrag 125 pis4 '(310 . 310) '( 840 .  44))
;;         (setq lon_min  40.0) (DesDrag 125 pis4 '(310 . 310) '(1120 .  44))
;;         (setq lon_min  30.0) (DesDrag 125 pis4 '(310 . 310) '(  10 . 314))
;;         (setq lon_min  20.0) (DesDrag 125 pis4 '(310 . 310) '( 280 . 314))
;;         (setq lon_min  15.0) (DesDrag 125 pis4 '(310 . 310) '( 560 . 314))
;;         (setq lon_min  10.0) (DesDrag 125 pis4 '(310 . 310) '( 840 . 314))
;;         (setq lon_min   7.0) (DesDrag 125 pis4 '(310 . 310) '(1120 . 314))
;;         (setq lon_min   5.0) (DesDrag 125 pis4 '(310 . 310) '(  10 . 584))
;;         (setq lon_min   3.0) (DesDrag 125 pis4 '(310 . 310) '( 280 . 584))
;;         (setq lon_min   2.0) (DesDrag 125 pis4 '(310 . 310) '( 560 . 584))
;;         (setq lon_min   1.0) (DesDrag 125 pis4 '(310 . 310) '( 840 . 584)))
;;    Autres "Dragons"...
;;       (DesDrag 155 pis4       '(310 . 310))
;;       (DesDrag 80 (* pi 0.75) '(310 . 180))
;;       (DesDrag 84 (- pi pis4) '(310 . 180))

;; N.B. LispWorks Personal 5.1.1 (2009, 2.6 GHz Intel Core 2 Duo) :
;; a du mal avec les gros dessins... Pour rcuprer de la place mmoire...
;;    voir avant:  (room)
;;    en faire :   (mark-and-sweep 3)
;;    voir aprs : (room)

;;       (DesDrag 355 pis4       '(680 . 520))
;;       (DesDrag 400 pis4       '(680 . 520)) ;mme... (setq lon_min 0.5)
;; "Crabe" :
;;       (DesCrab 125 0    '(310 . 310))
;;       (DesCrab 200 pis4 '(430 . 350))
;; "Vegetal" :
;;       (DesVeget 125 0    '(310 . 310))
;;       (DesVeget 250 0    '(310 . 510))
;;       (DesVeget 550 pis4 '(850 . 730))
;; "Triangle" :
;;       (DesTri 176 0    '(310 . 310))
;;       (DesTri 176 pis4 '(310 . 310))
;; "Grappe" :
;;       (DesGrappe 125 0    '(310 . 310))
;;       (DesGrappe 415 pis4 '(490 . 430))
;; "Virgule" :
;;       (DesVirgu 125 pis4 '(310 . 310))

(defparameter pos-h-orig 100)         ;Coordonnes rectangulaires de l'origine :
(defparameter pos-v-orig 100)         ;point (100 . 100)
(defparameter pos-h nil)              ;Coordonnes courantes en cours de trac
(defparameter pos-v nil)

(defparameter rac2    (sqrt 2.0))     ;Dfinitions prliminaires
(defparameter pis4    (/ pi 4.0))
(defparameter lon_min 2.0       )     ;pas 1.0... pour soulager LispWorks !

(defun DesC (lon ang taille &optional (pos '(10 . 44));<-AVEC POS. FEN. possible
                 &aux *fen*)
  (setq *fen* (capi::contain                            ;Fonction rcursive qui
               (make-instance 'capi::output-pane)       ;doit tracer un vecteur
               :best-x (car pos) :best-y (cdr pos)      ;dans une fentre :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-C-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a)                               ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (progn (interne (/ l rac2)             ;... le diviser en 1...
                                 (+ a pis4))
                        (interne (/ l rac2)             ;... puis 2 vecteurs...
                                 (- a pis4))))))
    (interne lon ang)))

(defun DesDrag (lon ang taille &optional (pos '(10 . 44));<-AVEC POS. FEN. poss.
                 &aux *fen*)
  (setq *fen* (capi::contain                            ;Fonction rcursive qui
               (make-instance 'capi::output-pane)       ;doit tracer un vecteur
               :best-x (car pos) :best-y (cdr pos)      ;dans une fentre :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Drag-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   (not sens))
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   sens))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   sens)
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   (not sens)))))))
    (interne lon ang t)))

(defun DesCrab (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain                           ;Fonction rcursive qui
               (make-instance 'capi::output-pane)      ;doit tracer un vecteur :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Crab-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   (not sens))
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   (not sens)))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   sens)
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   sens))))))
    (interne lon ang t)))

(defun DesVeget (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain                           ;Fonction rcursive qui
               (make-instance 'capi::output-pane)      ;doit tracer un vecteur :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Veget-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   (not sens))
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   sens))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   (not sens))
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   sens))))))
    (interne lon ang t)))

(defun DesTri (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain                           ;Fonction rcursive qui
               (make-instance 'capi::output-pane)      ;doit tracer un vecteur :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Tri-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   (not sens))
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   (not sens)))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   (not sens))
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   (not sens)))))))
    (interne lon ang t)))

;; Ci-dessous : gestions asymtriques des inversions de sens...

(defun DesGrappe (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain                           ;Fonction rcursive qui
               (make-instance 'capi::output-pane)      ;doit tracer un vecteur :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Grappe-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   (not sens))
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   (not sens)))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   sens)
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   (not sens)))))))
    (interne lon ang t)))

(defun DesVirgu (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain                           ;Fonction rcursive qui
               (make-instance 'capi::output-pane)      ;doit tracer un vecteur :
               :best-width (car taille) :best-height (cdr taille)
               :title (string (gensym "Dessin-Virgu-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (labels ((interne (l a sens)                          ;elle dcide de...
             (if (< l lon_min) (tracer l a *fen*)       ;... le tracer ou de...
                 (if sens
                   (progn (interne (/ l rac2)           ;... le diviser en 1...
                                   (+ a pis4)
                                   sens)
                          (interne (/ l rac2)           ;... puis 2 vecteurs...
                                   (- a pis4)
                                   (not sens)))
                   (progn (interne (/ l rac2)           ;... avec gestion des...
                                   (- a pis4)           ;... inversions de sens
                                   sens)
                          (interne (/ l rac2)
                                   (+ a pis4)
                                   sens))))))
    (interne lon ang t)))

;;   Conversion de vecteurs en coordonnes rectangulaires de l'extrmit 
;; atteindre. N'EST PLUS UTILE EN LispWorks : la conversion de vecteurs en
;; coordonnes cartsiennes est intgre  la fonction tracer ci-dessous.
;(defun next-pt (lon ang)
;  (let ((h (* lon (sin ang)))   
;        (v (* lon (cos ang))))
;    (incf pos-h h)
;    (incf pos-v v)
;    (values (round pos-h) (round pos-v))))

;;   Trac rel d'un segment de droite dans <fenetre> := un vecteur de longueur
;; <lon> et d'angle <ang>, commenant au point courant (<pos-h> . <pos-v>).
;; L'extrmit du vecteur trac devient ensuite le nouveau point courant.
;; Possible de modifier l'paisseur [<epais> = 1 par dfaut].

(defun tracer (lon ang fenetre &optional (epais 1))
  (capi::apply-in-pane-process fenetre 'gp::draw-line fenetre
                               pos-h
                               pos-v
                               (incf pos-h (* lon (sin ang)))
                               (incf pos-v (* lon (cos ang)))
                               :thickness epais))

;;   Petit utilitaire : cre un point aux coordonnes courantes
;; (<pos-h> . <pos-v>).

(defun pos () (cons pos-h pos-v))

;;   Pour tests : fonction produisant le trac d'un carr. Exemple :
;;    (carre 66 pi '(150 . 150))

(defun carre (lon ang taille &aux *fen*)
  (setq *fen* (capi::contain
               (make-instance 'capi::output-pane)
               :best-width (car taille)
               :best-height (cdr taille)
               :title (string (gensym "Dessin-"))))
  (setq pos-h pos-h-orig)
  (setq pos-v pos-v-orig)
  (format t "Dpart : ~5D ~5D~%" (car (pos)) (cdr (pos)))
  (tracer lon ang *fen* 4)
  (format t "Fin 1 : ~5D ~5D~%" (car (pos)) (cdr (pos)))
  (tracer lon (incf ang (/ pi 2.0)) *fen*)
  (format t "Fin 2 : ~5D ~5D~%" (car (pos)) (cdr (pos)))
  (tracer lon (incf ang (/ pi 2.0)) *fen* 4)
  (format t "Fin 3 : ~5D ~5D~%" (car (pos)) (cdr (pos)))
  (tracer lon (incf ang (/ pi 2.0)) *fen*)
  (format t "Fin 4 : ~5D ~5D~%" (car (pos)) (cdr (pos))))
