;===============================================================================
;;; 12.suppl --> EXEMPLE SUPPLMENTAIRE let et labels
;$$ 12.suppl --> ZUSTZLISCHES Beispiel fr let und labels            [d..H.B.]
;++ 12.suppl --> EXTRA let and labels Example
;===============================================================================

;;    Pour obtenir un tableau des frquences tempres et des MIDI pitches
;; correspondants, valuer l'ensemble de ce fichier.
;;    Il est possible de modifier le diapason, et, ventuellement, d'autres
;; paramtres.
;$   Fhre diese ganze Datei aus, um eine Tabelle der temperierten Frequenzen
;$ und der entsprechenden MIDI Pitches zu erhalten.
;$   Es ist mglich den Kammerton und eventuell auch andere Parameter zu
;$ verndern.
;+   To obtain a table of tempered frequencies and corresponding MIDI pitches,
;+ evaluate this entire file.
;+   It is possible to modify the tuning pitch, and eventually other parameters.

(let* ((diapason 440.0)
       (NoDiap    69  )
       (NoMIDI     0  )
       (PremOct   -2  )
       (NbrOct    11  )
       (symbo    '(C C# D D# E F F# G G# A A# B))
       (NbrNot    (list-length symbo))             )
  (format t "~2%~64TTableau  FREQUENCES  / NOTES MIDI~2%")
  (format t "~7T")
  (dotimes (n NbrNot)
    (format t "|~6@A      " (nth n symbo)))
  (format t "|")
  (labels ((ligne (n)                       ;tracer une ligne de <n> colonnes
             (format t "~%~2T-----")
             (dotimes (m n)
               (format t "|------------"))
             (format t "|~%")))
    (ligne NbrNot)
    (dotimes (noct NbrOct)
      (format t "~5D  " (+ noct PremOct))
      (dotimes (nnot NbrNot)
        (format t "|~8,2F"
                (* diapason (expt 2.0
                                  (/ (- (setq NoMIDI (+ (* noct NbrNot) nnot))
                                        NoDiap)
                                     NbrNot))))
        (if (< NoMIDI 128) (format t "/~3D" NoMIDI)
            (format t "    ")))
      (format t "|")
      (ligne NbrNot)))
  'ok)
