;;; Prparation de donnes cobayes pour dmonstration de diverses fonctions de
;;; ped.14 : faire-svp, faire-notes et iCs

;; Dfinitions pralables extraites d'exemples du cours
; Cf. ped.12
(defun faire-liste (fonction &optional (nbr 10))
  (labels ((interne () (cond
            ((= 0 nbr) ())
            (t (decf nbr)
               (cons (eval fonction) (interne))))))
    (interne)))
(defun integ (liste &optional (cumul 0))
  (labels ((interne (li)
             (if (endp li) ()
             (cons (incf cumul (car li)) (interne (cdr li))))))
    (cons cumul (interne liste))))
; Cf. ped.13
(defun cirlist (n)
  (let ((li (list n)))
    (nconc li li)))
(defun A->B (listA &aux temp rez)
    (setq temp (apply #'min listA))
    (setq temp (/ (apply #'max listA) temp))
    (dolist (la_valeur listA (reverse rez))
      (setq rez (cons (* (/ la_valeur -440.0) temp)
                      rez))))

;; Frquences
(setq frqs1 (faire-liste '(+ 110.0 (random 770.0)) 20))
(setq frqs2 (mapcar #'* frqs1 (cirlist 4)))
(setq frqs3 (mapcar #'(lambda (val)(+ (- val 0.5) (random 1.0)))     ;cf. ped.13
                            frqs1))
(setq frqs4 (mapcar #'(lambda (val)(+ (- val 0.5) (random 1.0)))     ;cf. ped.13
                            frqs3))

;; Dures
(setq durs1 (faire-liste '(1+ (random  5.0)) 20))
(setq durs2 (faire-liste '(1+ (random 10.0)) 20))
(setq durs3 (faire-liste '(1+ (random 15.0)) 20))
(setq durs4 (faire-liste '(1+ (random 20.0)) 20))

;; Dates
(setq dats1 (integ (butlast durs1))) 
(setq dats2 (integ (butlast durs2)))
(setq dats3 (integ (butlast durs3)  5.0))
(setq dats4 (integ (butlast durs4) 10.0))

;; dB
(setq dbs1 (mapcar #'- (faire-liste '(+ 3 (random 18)) 20)))
(setq dbs2 (mapcar #'- (faire-liste '(+ 6 (random 21)) 20)))
(setq dbs3 (A->B frqs1))
(setq dbs4 (A->B frqs2))

;; largeurs de bandes
(setq bws1 (faire-liste '(+ 10 (random 100.0)) 20))
(setq bws2 (mapcar #'* (faire-liste '(+ 10 (random 100.0)) 20) (cirlist 2)))
(setq bws3 (mapcar #'* (faire-liste '(+ 10 (random 100.0)) 20) (cirlist 4)))
(setq bws4 (mapcar #'* (faire-liste '(+ 10 (random 100.0)) 20) (cirlist 8)))

;; indices MF
(setq inds1 (faire-liste '(random 5.0) 20))
(setq inds2 (faire-liste '(+ 1 (random 5.0)) 20))
(setq inds3 (faire-liste '(+ 3 (random 6.0)) 20))
(setq inds4 (faire-liste '(+ 6 (random 8.0)) 20))