;; <1> Definition des Wurzel-Paths
(setq common-lisp::*wurzel-path*
  (merge-pathnames
    (make-pathname :directory (pathname-directory *load-truename*)) "*"))
;; <2> Zustzliche Aufladung(en)
(dolist (lefic '(
                 "ped.17.1.lisp"
                 ))
  (load (setq lefic (merge-pathnames lefic common-lisp::*wurzel-path*)))
  (format t "~&;; Geladen ~S~%" lefic))
;===============================================================================
;;; 17.2 --> MACRO-CARACTRES : primitive set-macro-character
;$$ 17.2 --> MAKRO-ZEICHEN: set-macro-character Primitive             [d..H.B.]
;++ 17.2 --> MACRO-CHARACTERS: set-macro-character Primitive
;===============================================================================

;;   <n> : conversion Euros vers Francs franais, avec application de la rgle
;; d'arrondi au centime.
;$   <n>: Umwandlung von Euros in Franzsische Francs, mit Rundung zum
;$ nchsten Centime.
;+   <n>: conversion from Euros to French Francs, with rounding rule to nearest
;+ centime.

(defun euro (flux caractere) caractere            ;pour viter Warning... en MCL
 (* (round (* 6.55957 (read flux t nil t)) 0.01) 0.01))
(set-macro-character #\ #'euro)

;;   Macro-caractre "%" :=  macro-caractre "'" (quote).
;$   "%" Makrozeichen := "'" (einfaches Anfhrungszeichen) Makrozeichen.
;+   "%" macro-character := "'" (quote) macro-character.

(defun mon-quote (flux caractere) (declare (ignore caractere))             ;idem
  (list (quote quote) (read flux t nil t)))
(set-macro-character #\% #'mon-quote)

;;   Mme exemple pour "$", en style anti-quote.
;$   Dasselbe Beispiel fr "$", in Backquote-Schreibweise.
;+   Same example for "$", in back-quote style.

(defun mon-quote1 (flux caractere) (declare (ignore caractere))
  `(quote ,(read flux t nil t)))
(set-macro-character #\$ #'mon-quote1)

;;   Cf. Gdel et fonction nen de ped.11.1 :
;$   Vgl. Gdel und die nen-Funktion von ped.11.1
;+   Cf. Gdel and nen function of ped.11.1:
;-    @<n> := (1+ <n>)

(defun escargot (flux caractere) caractere
  (list (quote 1+) (read flux t nil t)))
(set-macro-character #\@ #'escargot)

;;   "Antidote" du prcdent, en style anti-quote :
;$   "Gegengift" des vorangegangenen, in Backquote-Schreibweise:
;+   "Antidote" of the preceding, in back-quote style:
;-    {<n> := (1- <n>)

(defun ehcelf (flux caractere) caractere
  `(1- ,(read flux t nil t)))
(set-macro-character #\{ #'ehcelf)

;;   Exemple de macro-caractre expans en une macro-fonction :
;$   Beispiel eines Makrozeichens, das zu einer Makrofunktion erweitert wird:
;+   Example of a macro-character expanded into a macro-function:
;-    }<symbole> := (incr2 <symbole>)
;; La macro-fonction incr2 -- quivalente  la primitive incf -- est dfinie
;; dans le fichier ped.17.1. <symbole> doit avoir une valeur numrique.
;$ Die incr2-Makrofunktion -- Equivalent zum incf-Primitive -- wurde in Datei
;$ ped.17.1 definiert. <symbole> muss einen numerischen Wert haben.
;+ The incr2 macro-function--equivalent to the incf primitive--is defined in the
;+ ped.17.1 file. <symbole> must have a numerical value.

(defun fleche (flux caractere) caractere
  `(incr2 ,(read flux t nil t))) 
(set-macro-character #\} #'fleche)

;;   Pour disposer des caractres "" "{" et "}" dans la fentre de l'interprte
;; LISP, aux fins de dmonstrations.
;$   Um die "" "{" und "}"-Zeichen zu Demonstrationszwecken in einem
;$ LISP-Interpreter-Fenster zu erhalten.
;+   In order to have the "" "{" and "}" characters in the LISP interpreter
;+ window for demonstrations.

(format t "~&;Euro cnv : ~%")
(format t "~&;fleche G : {~%")
(format t "~&;fleche D : }~%")
