;;;=============================================================================
;;; 18.2 - Annexe C --> FILTRES LABORS (pattern matching) : liaison d'lments
;;;                     d'assertions    des  variables  de  filtres,  calcul de
;;;                     contraintes et d'lments de filtres
;;;
;;;               z. ->  CHARGER : MISE EN ROUTE ET EXEMPLES
;;;                     Chargement de l'ensemble des fonctions et dfinition des
;;;                     filtres tests ci-dessous
;;;=============================================================================

;;   Chargement des trois fichiers de fonctions.

;; <1> Definition des Wurzel-Paths
(setq common-lisp::*wurzel-path*
  (merge-pathnames
    (make-pathname :directory (pathname-directory *load-truename*)) "*"))
;; <2> Zustzliche Aufladung(en)
(dolist (lefic '(
                 "ped.18.2-AnxC.a.lisp"
                 "ped.18.2-AnxC.b.lisp"
                 "ped.18.2-AnxC.c.lisp"
                 ))
  (load (setq lefic (merge-pathnames lefic common-lisp::*wurzel-path*)))
  (format t "~&;; Geladen ~S~%" lefic))

(format t "~&~%; ATTENTION : il FAUT +clinit.lisp et ped.d/+clinit.lisp !~2%")

;;   On suppose charg un fichier dfinissant les variables a b c x y z (cf.
;; ped.d/+clinit.lisp

;;   Varier ici la valeur de bugbug, selon les besoins... Cf. ped.18.2-AnxC.b.

(setq bugbug t)                                         ;t => DEBUG ; nil => non
(bug)

;;; Divers,  tester avec l'assertion b := (1 (2 (3)) 4 (5 6) 7 8) ou
(setq bb (append b '(1)))

(setqq p1 (~prem (_sec (@(+ prem sec))) _kat ~reste 8 @prem))
  ;(f3 p1 bb) => T
(setqq p1b (_prem (_sec (@(+ prem sec))) _kat ~reste 8 @prem))
  ;(f3 p1b bb) => T
(setqq p2 (~prem (~sec (@(+ prem sec))) _kat ~reste 8 @prem))
  ;(f3 p2 bb) => Error
  ;(f3 p2 bb :rien -99999999) => t
  ;(f3 p2 '(77 (4 (81)) 444 (5 6) oi po pi p7 8 77)                ) => Error
  ;(f3 p2 '(77 (4 (81)) 444 (5 6) oi po pi p7 8 77) :rien -99999999) => t
  ;(f3 p2 '(77 (4 ( 1)) 444 (5 6) oi po pi p7 8 77) :rien -99999999) => Error

;;; Divers palindromes et formes symtriques

(setqq p3 (~prem ~reste @prem))                            ;quelques truismes...
  ;(f3 p3 (append x c y b z a))
  ;(f3 p3 ())
(setqq p3b (~prem % ~reste @prem))
  ;(f3 p3b (append x c y b z a))
  ;(f3 p3b ())
(setqq p3bis (~prem $ ~reste @prem))                       ;... ou presque
  ;(f3 p3bis (append x c y b z a))
  ;(f3 p3bis '(zut))
  ;(f3 p3bis 'zut)
  ;(f3 p3bis ())
(setqq p3c (_prem ~reste @prem))
  ;(f3 p3c '(debut             debut))
  ;(f3 p3c '(debut m i l i e u debut))
  ;(f3 p3c '(debut 1 2             2 1 debut))
  ;(f3 p3c '(debut 1 2 m i l i e u 2 1 debut))
(setqq p3cis ($prem ~reste @prem))
  ;(f3 p3cis '(debut             debut))
  ;(f3 p3cis '(debut m i l i e u debut))
  ;(f3 p3cis '(debut 1 2             2 1 debut))
  ;(f3 p3cis '(debut 1 2 m i l i e u 2 1 debut))

(setqq p4 ($A $B @A))                                      ;VRAI "A B A"
  ;(f3 p4 '(debut             debut))
  ;(f3 p4 '(debut m i l i e u debut))
  ;(f3 p4 '(debut 1 2             2 1 debut))
  ;(f3 p4 '(debut 1 2 m i l i e u 2 1 debut))
  ;(f3 p4 '(debut 1 2             2 1 debut 1 2))
  ;(f3 p4 '(debut 1 2 m i l i e u 2 1 debut 1 2))

;;; Rptitons avec/sans variantes

(setq p97 '($a @a))                                                      ;simple
  ;(f3 p97 (append a b x y a b x y)) => t et bonne liaison
  ;(f3 p97 (append a b x y '(x) a b x y)) => nil
(setq p98 '($a @a ~f2) )                                 ;avec coda  la reprise
  ;(f3 p98 (append a x '(x) a x '(x y z z z))) => t et bonne liaison
  ;(f3 p98 (append a a '(x) a a '(x y z z z))) => t mais liaison minimale
(setq p99 '($a ~f1 @a ~f2) )                              ;avec deux codas diff.
  ;(f3 p99 '(je repete ceci je repete ceci oui)) => t mais liaison minimale
(setq p96 '($a ceci ~f1 @a ceci ~f2) )                    ;avec deux codas diff.
  ;(f3 p99 '(je repete ceci je repete ceci oui)) => t mais liaison tjrs minimale

(setqq p5 (~prem @(palindro1 prem)))
  ;(f3 p5 '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p5 '(b u r g r u b)) => nil
(setqq p5b (~prem %milieu @(palindro1 prem)))
  ;(f3 p5b '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p5b '(b u r g r u b)) => t
  ;(f3 p5b '(a)) => nil
  ;(f3 p5b '(a nil)) => t : cas extrme...
(setqq p5c (~prem %milieu @(when (not (eq '*rien* prem)) (palindro1 prem))))
  ;(f3 p5c '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p5c '(b u r g r u b)) => t
  ;(f3 p5c '(a)) => nil
  ;(f3 p5c '(a nil)) => t : cas extrme...
(setqq p5d ($prem %milieu @(palindro1 prem)))
  ;(f3 p5d '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p5d '(b u r g r u b)) => t
  ;(f3 p5d '(a)) => nil
  ;(f3 p5d '(a nil)) => t : cas extrme...
(setqq p5e ($A $B @(palindro1 A)))                  ;"A B (rtro de A)" INSUFFI.
  ;(f3 p5e '(1 2 3 x y z 3 2 1))
;;   NB: UN NIVEAU DE () DE PLUS POUR des squences dans un ?_...
(setqq p5f (?_((_a1 _a2 _a3) (_a1 _a2))             ;"A B (rtro de A)" (MIEUX?)
           $B ?_((@a3 @a2 @a1) (@a2 @a1))))         ;mais A de 2 ou 3 lments
  ;(f3 p5f '(1 2 3 x y z 3 2 1)) => t
  ;(f3 p5f '(1 2   x y z   2 1)) => t, mais a3 => x !
  ;(f3 p5f '(1 2   x y z   2 k)) => nil
  ;(f3 p5f '(1     x y z     1)) => nil
(setqq p5g ($A                                      ;"A B (rtro de A)" BON si B
           _premB ~milB ^(not(equal & premB))       ;au moins 2 lments. (cf.
           @(palindro1 A)))                         ;p5b pour B de 0 ou 1 lem.)
  ;(f3 p5g '(1 2 3 x y z 3 2 1)) => t
  ;(f3 p5g '(1 2   x y z   2 1)) => t
  ;(f3 p5g '(1 2   x y z   2 k)) => nil
  ;(f3 p5g '(1     x y z     1)) => nil             ;ceci DEVRAIT donner t mais
                                                    ;palindro1 n'est pas adapte
                                                    ; => nouvelle rdaction :
(setqq p5gg ($A                                     ;marche mme si A a un nbr
           _premB ~milB ^(not(equal & premB))       ;quelconque d'lments,
           ?_((@A) (@(palindro1 A)))))              ;mme 1 seul
  ;(f3 p5gg '(1 2 3 x y z 3 2 1)) => t
  ;(f3 p5gg '(1     x y z     1)) => t
(setqq p5h ($A                                      ;"A B (rtro de A)" BON si B
           _premB ~milB ^derB(not (equal & premB))  ;au moins 2 lments.
           ?_((@A) (@(palindro1 A)))))
  ;(f3 p5h '(1 2 3 x y z 3 2 1)) => t
  ;(f3 p5h '(1 2   x y z   2 1)) => t
  ;(f3 p5h '(1 2   x y z   2 k)) => nil
  ;(f3 p5h '(1     x y z     1)) => t
  ;(f3 p5h '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => nil
  ;(f3 p5h '(b u r g r u b)) => nil
  ;(f3 p5h '(b u r g h r u b)) => t
;;   p5i : autre faon de faire mme chose. NB : un niveau de () de plus pour un
;; ^ dans un ?_, afin que l'expression (^ nil (not (equal & premB))) ne soit pas
;; insre comme une squence de plusieurs lments ^ nil (not...) en tte du
;; filtre.
(setqq p5i ($A
           _premB ~milB ?_derB((^(not (equal & premB))))
           ?_((@A) (@(palindro1 A)))))
  ;(f3 p5i '(1 2 3 x y z 3 2 1)) => t
  ;(f3 p5i '(1 2   x y z   2 1)) => t
  ;(f3 p5i '(1 2   x y z   2 k)) => nil
  ;(f3 p5i '(1     x y z     1)) => t
  ;(f3 p5i '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => nil
  ;(f3 p5i '(b u r g r u b)) => nil
;Ceci peut impliquer la ncessit d'une recherche  partir du plus grand nombre
;possible d'lements d'assertion, et non pas du plus petit comme % $ et ~. Cf.
;tentative inacheve de }.
(setqq p5j ($A $milieu @(palindro1 A)))
  ;(f3 p5j '(a b c d 1 2 3 4 d c b a)) => t mais A=(a b) et non (a b c d)
;MAIS ceci peut tre OK avec p5h ou p5i ci-dessus, si au moins 2 lm. milieu
  ;(f3 p5h '(a b c d 1 2 3 4 d c b a)) => t avec A=(a b c d) !
  ;(f3 p5i '(a b c d 1 2 3 4 d c b a)) => t avec A=(a b c d) !

;;; Palindromes avec restriction de l'lment central s'il existe

(setqq p10 (~debut ?%centre(^(member & '(mil lim))) @(palindro1 debut)))
  ;(f3 p10 '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p10 '(b u r g   r u b)) => nil : le centre n'est pas mil ou lim
  ;(f3 p10 '(b u r     r u b)) => t
  ;(f3 p10 '(b u r mil r u b)) => t
  ;(f3 p10 '(b u r lim r u b)) => t
(setqq p10b (~deb ?%centre(ala ^(member & '(mil lim))) @(palindro1 deb)))
  ;(f3 p10b '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p10b '(b u r g   r u b)) => nil : le centre n'est pas ala ou mil ou lim
  ;(f3 p10b '(b u r     r u b)) => t
  ;(f3 p10b '(b u r mil r u b)) => t
  ;(f3 p10b '(b u r lim r u b)) => t
  ;(f3 p10b '(b u r ala r u b)) => t
(setqq p10c (~debut ?~centre(mil lim) @(palindro1 debut)))             ;idem p10
  ;(f3 p10c '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p10c '(b u r g   r u b)) => nil : centre pas mil ou lim
  ;(f3 p10c '(b u r     r u b)) => t
  ;(f3 p10c '(b u r mil r u b)) => t
  ;(f3 p10c '(b u r lim r u b)) => t
(setqq p10d (~debut ?%centre(mil lim) @(palindro1 debut)))             ;idem p10
  ;(f3 p10d '(r a t s   l i v e   o n   n o   e v i l   s t a r)) => t
  ;(f3 p10d '(b u r g   r u b)) => nil : le centre n'est pas mil ou lim
  ;(f3 p10d '(b u r     r u b)) => t
  ;(f3 p10d '(b u r mil r u b)) => t
  ;(f3 p10d '(b u r lim r u b)) => t

;;; Contraintes sur des segments d'assertion

(setqq p7 (?_(a b c d) ~reste))
  ;(f3 p7 '(a 6 4 5 7 55 4)) => t
  ;(f3 p7 '(6 4 5 7 55 4 a)) => nil
(setqq p7b (?_prem(a b c d) ~reste @prem))
  ;(f3 p7b '(d 6 4 5 7 55 4 d)) => t
  ;(f3 p7b '(a 6 4 5 7 55 4)) => nil
  ;(f3 p7b '(6 4 5 7 55 4 a)) => nil
(setqq p7c (?_prem(0 1 2 3 4 5 6 7 8 9 ~autre) ~reste @prem))
  ;(f3 p7c '(d 6 4 5 7 55 4 d)) => t
  ;(f3 p7c '(a 6 4 5 7 55 4)) => nil
  ;(f3 p7c '(6 4 5 7 55 4 a)) => nil
  ;(f3 p7c '(6 4 5 7 55 4 a 6)) => t
(setqq p7d (?_prem(0 1 2 3 4 5 6 7 8 9 ~autre) ~reste @autre))       ;douteux...
  ;(f3 p7d '(d 6 4 5 7 55 4 d)) => t
  ;(f3 p7d '(a 6 4 5 7 55 4)) => t
  ;(f3 p7d '(6 4 5 7 55 4 a)) => Error
  ;(f3 p7d '(6 4 5 7 55 4 a 6)) => Error
(setqq p7e (?_prem(33 44 ~autre) $reste ?_(@prem @autre)))           ;douteux...
  ;(f3 p7e '(d 6 4 5 7 55 4 d)) => t
  ;(f3 p7e '(a 6 4 5 7 55 4)) => nil
  ;(f3 p7e '(a 6 4 5 7 55 4 a)) => t
  ;(f3 p7e '(6 4 5 7 55 4 a)) => nil
  ;(f3 p7e '(44 4 5 7 55 4 a 44)) => Error
(setqq p7g (?_prem((?_lettre (a b c d e)) (?_chiffre (1 2 3 4 5)))   ;douteux...
           ~reste
           @prem))
  ;(f3 p7g '(c li ju ga se co c)) => t
  ;(f3 p7g '(3 li ju ga se co 3)) => t
  ;(f3 p7g '(3 li ju ga se co b)) => nil
  ;(f3 p7g '(b li ju ga se co 3)) => nil
(setqq p7h (^prem(member & '(1 2 3)) ~reste))
  ;(f3 p7h a) => t
  ;(f3 p7h '(3 hg tyr kjh trds jdhs ieu hds nb)) => t

;;; Avec calculs divers, souvent de valeurs numriques -- ex. MIDI pitches

;;   ARPGE MAJEUR avec ventuelle(s) chappe(s). Rcupre fond
(setqq p6 (~foo _fond @(arpege fond) ~bar))
  ;(f3 p6 '(6 5 3 8 7 60 69 64 59 67 5 4 9 7 2 10)) => t
  ;(f3 p6 '(6 5 3 8 7 60 64 67 5 4 9 7 2 10)) => t
  ;(f3 p6 '(6 5 3 8 7 60 63 67 5 4 9 7 2 10)) => nil
(setqq p6g (~avant                            ;arpge MAJ./min.,  ventuellement
            _fond                             ;au milieu d'autres notes, ventu.
            %mou1                             ;avec une note trangre entre des
            ?_3ce((@(+ fond 3)) (@(+ fond 4)));notes principales
            %mou2                             ;Rcupre fond + 3ce
            @(+ fond 7)                       ;N.B. : un niveau de () de + pour
            ~apres))                          ;alternatives dans un ?_(...)
  ;(f3 p6g '(60 64 67)) => t
  ;(f3 p6g '(9 60 63 67 8)) => t
  ;(f3 p6g '(9 69 33 73 55 76 8)) => t
  ;(f3 p6g '(5 3 9 7 2 6 50 5 53 57 8 6 4 3 9 8)) => t
;; arpege majeur en ordre qcq  l'intrieur d'une sq. qcq
;;   NB: UN NIVEAU DE () DE PLUS POUR des squences alternatives dans un ?_...
(setqq arpeg4 (~avant
               _prem
               _sec
               ?_tro((^(and (= (- sec prem)  4) (= & (+ sec  3))))
                     (^(and (= (- sec prem)  7) (= & (+ sec -3))))
                     (^(and (= (- sec prem)  3) (= & (+ sec -7))))
                     (^(and (= (- sec prem) -4) (= & (+ sec  7))))
                     (^(and (= (- sec prem) -7) (= & (+ sec  4))))
                     (^(and (= (- sec prem) -3) (= & (+ sec -4)))))
               ~apres))
  ;(f3 arpeg4 '(2 4 3 5 6 7 4 6 64 60 67 6 8 5 6 99 22)) => t et identif. OK
;;   NB: UN NIVEAU DE () DE PLUS POUR des squences alternatives dans un ?_...
(setqq p6a (~avant
            _note
            ?_((@note @note)                         ;TROIS NOTES RPTES dont
               (@(brod note) @note)                  ;ventuellement une <brod>
               (@note @(brod note)))                 ;de +/- un demi-ton
            ~apres))
  ;(f3 p6a '(5 6 7 4 2 9 60 59 60 4 8 7 6 3 2 9)) => t
  ;(f3 p6a '(5 6 7 4 2 9 60 60 61 4 8 7 6 3 2 9)) => t
  ;(f3 p6a '(5 6 7 4 2 9 60 59 61 4 8 7 6 3 2 9)) => nil
; rpt. de deux notes  un intervalle de un ou deux dt qq part dans une sq.
(setqq trille2 (~avant _prem ?_sec((^(= 1 (abs (- & prem))))
                                   (^(= 2 (abs (- & prem)))))
                       @prem @sec
                ~apres))
  ;(f3 trille2 '(0 8 5 4 8 7 5 6 5 6 3 7 7 4 5 6 7 8 9)) => t et identif. OK
  ;(f3 trille2 '(0 8 5 4 8 7 5 6 9 6 3 7 7 4 5 6 7 8 9)) => nil
(setqq p6b (                                         ;trait d'au moins 2 notes,
    _basse                                           ;strictement ascendant ??
    ~milieu
    ^haute(apply #'< (append (list basse)
                             (when (qqch milieu)
                               (if (consp milieu) milieu
                                   (list milieu)))
                             (list  &)))))    ;ma premire rdaction => Error
                             ;(list (if &  & -999)))))) ;ceci vite les 2 Error
                             ;ci-dessous (Raphale Biston 11/02/05)
  ;(f3 p6b '(10 20 30 40 50)) => t
  ;(f3 p6b '(10)) => Error
  ;(f3 p6b '(10 20 40 40 50)) => t
  ;(f3 p6b '(10 20 40 30 50)) => t
  ;(f3 p6b '(10 20 40 30  9)) => Error
(setqq p6d (                                         ;trait d'au moins 2 notes,
    _haute                                           ;avec fin + grave que dbut
    ~milieu
    ^basse(when (and & haute) (< & haute))))
  ;(f3 p6d '(72)) => nil
  ;(f3 p6d '(72 55)) => t
  ;(f3 p6d '(66 89)) => nil
  ;(f3 p6d '(66 4 5 6 3 4 5 8 9 10 48)) => t
(setqq p6e (                                         ;trait d'au moins 3 notes,
    _haute                                           ;avec une au milieu + grave
    ~mou1                                            ;que dbut et fin + grave
    ^milieu(when & (< & haute))                      ;que milieu : globalement
    ~mou2                                            ;descendant
    ^basse(when & (< & milieu))))
  ;(f3 p6e '(77 55)) => nil
  ;(f3 p6e '(77 55 66)) => nil
  ;(f3 p6e '(88 5 6 7 4 9 77 4 5 6 3 9 7 5 3 8 66)) => t
;; mme chose ascendant OU descendant...
(setqq ascOUdesc
  (?_((_prem ~mou1 ^sec(when & (> & prem)) ~mou2 ^troi(when & (> & sec)))
      (_prem ~mou1 ^sec(when & (< & prem)) ~mou2 ^troi(when & (< & sec))))))
  ;(f3 ascOUdesc '(88 5 6 7 4 9 77 4 5 6 3 9 7 5 3 8 66)) => t et bonne identif.
  ;(f3 ascOUdesc '(22 5 6 7 4 9 44 4 5 6 3 9 7 5 3 8 66)) => t et bonne identif.
(setqq p6f (                                         ;trait d'au moins 5 notes,
    _haute                                           ;avec une au milieu + grave
    $mou1                                            ;que dbut et fin + grave
    ^milieu(when & (< & haute))                      ;que milieu : globalement
    $mou2                                            ;descendant
    ^basse(when & (< & milieu))))
  ;(f3 p6f '(77 55 66)) => nil
  ;(f3 p6f '(77 66 65)) => nil
  ;(f3 p6f '(77 3 66 4 65)) => t
  ;(f3 p6f '(88 5 6 7 4 9 77 4 5 6 3 9 7 5 3 8 66)) => t
  ;(f3 p6f '(88 50 60 70 40 99 77 40 50 60 30 90 70 50 30 80 66)) => t mais 
  ;dtecte un autre milieu : premire solution satisfaisante tjrs accepte

;;; Contraintes arithmtiques et de symrie de l'assertion

;;   NB: UN NIVEAU DE () DE PLUS POUR ^( . . .) dans un ?_(...)
(setqq p8 (?_prem((^(> & 100)) (^(< & -100))) ~reste @prem))
  ;(f3 p8 '(333 poi poi poi poi 333)) => t
  ;(f3 p8 '(-333 g h dqs dg ys fg qs jyf jsq g -333)) => t
  ;(f3 p8 '(333 poi poi poi poi)) => nil
  ;(f3 p8 '(67 g h dqs dg ys fg qs jyf jsq g 67)) => nil
(setqq p8a (^prem(> (abs &) 100) ~reste @prem))                         ;idem p8
  ;(f3 p8a '(333 poi poi poi poi 333)) => t
  ;(f3 p8a '(-333 g h dqs dg ys fg qs jyf jsq g -333)) => t
  ;(f3 p8a '(333 poi poi poi poi)) => nil
  ;(f3 p8a '(67 g h dqs dg ys fg qs jyf jsq g 67)) => nil
(setqq p8b (^prem(and (> & 0) (< & 10)) ~reste @prem))
  ;(f3 p8b '(-333 g h dqs dg ys fg qs jyf jsq g -333)) => nil
  ;(f3 p8b '(5 g h dqs dg ys fg qs jyf jsq g 5)) => t
(setqq p8d (~deb ^mil(and (> & 0) (< & 10)) ~fin))
  ;(f3 p8d '(5 g h dqs dg ys fg qs jyf jsq g 5)) => t
  ;(f3 p8d '(g h dqs dg ys fg qs jyf jsq g 5)) => Error
  ;(f3 p8d '(55 66 77 44 33 5 88 77 55 33 22 11)) => t
(setqq p8e ($deb ?_mil((^(> & 10)) 6 (^(< & 0))) $fin))
  ;(f3 p8e '(675   33 832)) => t
  ;(f3 p8e '(675    6 832)) => t
  ;(f3 p8e '(675 -876 832)) => t
  ;(f3 p8e '(675    5 832)) => nil
;;   NB: UN NIVEAU DE () DE PLUS POUR @ dans un ?_...
(setqq p8f (?_prem(1 2 3 4 5 6 7 8 9 0) ~reste ?_fin((@prem) zut)))
  ;(f3 p8f '(4 hg fd tr uy hg rt bv dx jh 4  )) => t
  ;(f3 p8f '(0 hg fd tr uy hg rt bv dx jh zut)) => t

;;; Contraites sur des segments et la symtrie de l'assertion

(setqq p9 (?$(a b c d) ~reste))
  ;(f3 p9 '(a b d a b a c d c d b a 4 1 2 3 6 4 1 0 3 6 2 5 4 1)) => t 
(setqq p9b (?$deb(a b c d) ?_(w x q) ~reste @deb))
  ;(f3 p9b '(a b d a   4 1 2 3 6 4 1 0 3 6 2 5 4 1 a      )) => nil 
  ;(f3 p9b '(a b d c x 4 1 2 3 6 4 1 0 3 6 2 5 4 1 a b d c)) => t
;;   DANGER p9c : rdaction incohrente : boucle infinie ?$prem et ~autre :
;; <limite> doit tre 2me d'ass.
(setqq p9c (?$prem(0 1 2 3 4 5 6 7 8 9 ~autre) limite ~reste @prem))
  ;(f3 p9c '(6 limite hj ty gf rt fd re df vc 6)) => t
  ;(f3 p9c '(6 7 limite hj ty gf rt fd re df vc 6)) => ...
  ;(f3 p9c '(6 7 4 5 limite hj ty gf rt fd re df vc 6)) => ...
(setqq p9d (?$prm(a b c d) ?_(w x q (^(member & '(un de)))) ~r ?_((@prm) zut)))
  ;(f3 p9d '(a d    q    5 7 4 8 0 5    a d)) => t
  ;(f3 p9d '(a d   un    5 7 4 8 0 5    a d)) => t
  ;(f3 p9d '(a d   de    5 7 4 8 0 5    zut)) => t
(setqq p9e (?_prem(a b c d) ?_(w x q) ~reste ?_((@prem) zut)))
  ;(f3 p9e '(a b d c x 4 1 2 3 6 4 1 0 3 6 2 5 4 1 a b d c)) => nil
  ;(f3 p9e '(c   x   4 1 2 3 6 4 1 0 3 6 2 5 4 1   c)) => t
  ;(f3 p9e '(b   x   4 1 2 3 6 4 1 0 3 6 2 5 4 1 zut)) => t
;;  p9f et p9g : ~reste prend tout ds que ass. dbute par 1 ou 2 de {a b c d}.
(setqq p9f (?$deb(a b c d) ?%(a b c d) ~reste))
  ;(f3 p9f '(a b d c x 4 1 2 3 6 4 1 0 3 6 2 5 4 1 a b d c)) => t
(setqq p9g (?$deb(a b c d) ?_(a b c d) ~reste))
  ;(f3 p9g '(a b d c x 4 1 2 3 6 4 1 0 3 6 2 5 4 1 a b d c)) => t

;;; Vers et rimes

; Squence de type (. . . . . . . . . rime1
;                   . . . . . . . . . rime2)
; = deux vers de longueur gale + liaison de leur dernier pied  rimeN
; Il faut au moins 2 pieds par vers, rime inclue
(setqq rimes2
  ($vers1 _rime1
   ?_vers2((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) _rime2))
  ;(f3 rimes2 '(1 a)) => nil
  ;(f3 rimes2 '(1 5 a e)) => t et identification OK dans tous les cas t
  ;(f3 rimes2 '(1 5 X a g e)) => t 
  ;(f3 rimes2 '(1 2 3 4 5 a b c d e)) => t                                                   ((VERS1 1 2 3 4) (RIME1 . 5) (VERS2 . A) (RIME2 . E))
  ;(f3 rimes2 '(1 2 3 4 5 a b c d e)) => t
  ;(f3 rimes2 '(1 2 3   5 a b c d e)) => NIL
  ;(f3 rimes2 '(p01 p02 p03 p04 rime1 p11 p12 p13 p14 rime2)) => t
; Le filtre rimes2 divise une squence de longueur paire en deux parties gales,
; et identifie le dernier lments de chacune de ces parties. a pourrait aussi
; bien tre identifi par une fonction ad hoc :
(defun adhoc (li)
  (let ((lng (list-length li)))
    (when (evenp lng) (values t
                              (nth (/ (- lng 2) 2) li)
                              (car (last li))))))
  ;Et mme mieux, car OK pour deux vers de 1 pied ex. : (adhoc '(a e)) => t
; Rdaction alternative, sans identification du dbut de vers2
(setqq rimes2a
  ($vers1 _rime1
   @(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))) _rime2))
  ;(f3 rimes2a '(1 2 3 4 5 a b c d e)) => t                                                   ((VERS1 1 2 3 4) (RIME1 . 5) (VERS2 . A) (RIME2 . E))
; Peut tre port au principe d'une strophe ex. : (. . . . . . . . . rime1
; (rimes croises)                                 . . . . . . . . . rime2
;                                                  . . . . . . . . . rime1
;                                                  . . . . . . . . . rime2)
(setqq rimes3
  ($vers1                                                               _rime1
   ?_vers2((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) _rime2
   ?_vers3((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) @rime1
   ?_vers4((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) @rime2))
  ;(f3 rimes3 '(a b c   1 2 3   v b c   7 5 3)) => t + id. OK vers1 rime1 rime2
  ;(f3 rimes3 '(a b c   1 2 3   v b c   7 5 Z)) => nil
  ;(f3 rimes3 '(a b c   1 2 3   v b c   7   3)) => nil
; Rdaction alternative, sans identification des dbuts des vers 2 sq.
(setqq rimes3a
  ($vers1                                                        _rime1
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) _rime2
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) @rime1
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) @rime2))
  ;(f3 rimes3a '(a b c d e   1 2 3 4 5   v b c w e   7 5 3 9 5)) => t
; Autre strophe ex. : (. . . . . . . . . rime1
; (rimes plates)       . . . . . . . . . rime1
;                      . . . . . . . . . rime2
;                      . . . . . . . . . rime2)
(setqq rimes4
  ($vers1                                                               _rime1
   ?_vers2((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) @rime1
   ?_vers3((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) _rime2
   ?_vers4((@(if (atom vers1) '((|_|))
             (make-list (list-length vers1) :initial-element '(|_|))))) @rime2))
  ;(f3 rimes4 '(a b c    1 2 3    v b c    7 5 Z)) => nil
  ;(f3 rimes4 '(a b c    1 2 c    v b Z    7 5 Z)) => t + id. OK vers1 & 2 rimes
; Rdaction alternative, sans identification des dbuts des vers 2 sq.
(setqq rimes4a
  ($vers1                                                        _rime1
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) @rime1
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) _rime2
   @(if (atom vers1) '((|_|))
        (make-list (list-length vers1) :initial-element '(|_|))) @rime2))
  ;(f3 rimes4a '(a b c d e   1 2 3 4 e   v b c w 5   7 5 3 9 5)) => t

;;; Divers

;;   t pour "a a a" , "a" , "mou" ou "(a a)". NB: UN NIVEAU DE () DE + POUR
;; l'alternative (a a).
(setqq p12 (zut ?_corps((a a a) a mou ((a a))) 99 ~reste fin))
  ;(f3 p12 '(zut a a a 99 7 5 4 6 7 8 5 3 2 fin)) => t, mais corps mal rcupr
  ;(f3 p12 '(zut     a 99 7 5 4 6 7 8 5 3 2 fin)) => t
  ;(f3 p12 '(zut (a a) 99 7 5 4 6 7 8 5 3 2 fin)) => t
  ;(f3 p12 '(zut   mou 99 7 5 4 6 7 8 5 3 2 fin)) => t
;;   t pour "z z z" , "a" ou "mou". NB: UN NIVEAU DE () DE PLUS pour
;; l'alternative @(trois...).
(setqq p12b (zut ?_corps((@(trois 'z)) a mou) 99 ~reste fin))
  ;(f3 p12b '(zut z z z 99 7 5 4 6 7 8 5 3 2 fin)) => t, mais corps...
  ;(f3 p12b '(zut     a 99 7 5 4 6 7 8 5 3 2 fin)) => t
  ;(f3 p12b '(zut   mou 99 7 5 4 6 7 8 5 3 2 fin)) => t

(setqq p13 (36 ?~bla(^(and (> & 0)(< & 10)) 33) ?_ped((^(< & 0))) @bla))
  ;(f3 p13 '(36 6 5 3 7 6 9 2 1 5 -654654 6 5 3 7 6 9 2 1 5)) => t
  ;(f3 p13 '(36 33 33 33 33 33 33 -654654 33 33 33 33 33 33)) => t
  ;(f3 p13 '(36                33 -654654                33)) => t
  ;(f3 p13 '(36                   -654654                  )) => t
(setqq p13b (?~bla(^(and (> & 0)(< & 10)) 33) ?_ped((^(< & 0))) @bla 36))
  ;(f3 p13b '(4 5 6 3 2 9 7 6 -65765 4 5 6 3 2 9 7 6 36)) => t
  ;(f3 p13b '(33 33 33   1    -65765 33 33 33   1    36)) => t
  ;(f3 p13b '(                -65765                 36)) => t
;;   p13c et p13d ne marchent que si l'assertion a plus de 2 lments quand le
;; premier est ngatif.
(setqq p13c (?_ped((^(< & 0))) ?~bla(^(and (> & 0)(< & 10)) 33) @bla))
  ;(f3 p13c '(-55 33)) => Error
  ;(f3 p13c '(-55 33 33)) => t
  ;(f3 p13c '(-55   4 3 7 6 4 9 7 2 33   4 3 7 6 4 9 7 2 33)) => t
  ;(f3 p13c '(-55   4 3 7 6 4 9 7 2 33   4 3 7 6 4 9 7 2 33)) => t
  ;(f3 p13c '(-55   4 3 7 6 4 9 7 2 33   4 3 7 6 4   7 2 33)) => Error
  ;(f3 p13c '(955   4 3 7 6 4 9 7 2 33   4 3 7 6 4 9 7 2 33)) => nil
(setqq p13d (?_ped((^(< & 0))) ?$bla(^(and (> & 0)(< & 10)) 33) @bla))
  ;(f3 p13d '(-66  5 4 33 6 7 4 9 33 5 2 1 9  77)) => nil
  ;(f3 p13d '(-66  5 4 33 6 7 4 9 33 5 2 1 9  5 4 33 6 7 4 9 33 5 2 1 9)) => t

;;; Thorme des sous-suites monotones, Quven, 12/2009.

;;   De toute suite de (<n>**2)+1 nombres diffrents, on peut extraire une sous-
;; suite croissante de longueur <n>+1 ou une sous-suite dcroissante de longueur
;; <n>+1 [Erds, P. & Szekeres, G., 1935]. Cf. [DELAHAYE, J.-P., 2009 : "Le
;; dsordre total n'existe pas...", Pour la science : 376 : 86 sq.].

;; <n> = 3 ---------------------

(setqq ThSSM-3< (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~))
(setqq ThSSM-3> (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~))
  ;(f3 ThSSM-3< '(31 30 53 12 27 11 66 21 87 32))
  ;(f3 ThSSM-3> '(31 30 53 12 27 11 66 21 87 32))
  ;Ci-dessous, il se peut que les suites <sq> cres par le gnrateur alatoire
  ;ne contiennent pas des nombres tous diffrents, et/ou qu'une sous-suite
  ;croisssante ne soit pas possible. Dans ces cas on trouvera nanmoins une
  ;sous-suite dcroissante. 
  ;(let ((sq (faire-liste '(random 100) 10))) (print sq) (or (f3 ThSSM-3< sq) (f3 ThSSM-3> sq)))
  ;(let ((sq (faire-liste '(random 100) 10))) (print sq) (multiple-value-bind (V vars) (f3 ThSSM-3< sq) (if V (values V vars) (f3 ThSSM-3> sq))))

;; Encore mieux !!!

(setqq ThSSM-3<> (?_(
  (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~)
  (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~)
)))
  ;(let ((sq (faire-liste '(random 100) 10))) (print sq) (f3 ThSSM-3<> sq))

;; <n> = 4 ---------------------

(setqq ThSSM-4< (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~ ^n5(when & (> & n4)) ~))
(setqq ThSSM-4> (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~ ^n5(when & (< & n4)) ~))
  ;(let ((sq (faire-liste '(random 100) 17))) (print sq) (or (f3 ThSSM-4< sq) (f3 ThSSM-4> sq)))
  ;(let ((sq (faire-liste '(random 100) 17))) (print sq) (multiple-value-bind (V vars) (f3 ThSSM-4< sq) (if V (values V vars) (f3 ThSSM-4> sq))))

;; Encore mieux !!!

(setqq ThSSM-4<> (?_(
  (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~ ^n5(when & (> & n4)) ~)
  (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~ ^n5(when & (< & n4)) ~)
)))
  ;(let ((sq (faire-liste '(random 100) 17))) (print sq) (f3 ThSSM-4<> sq))

;; <n> = 5 ---------------------

(setqq ThSSM-5< (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~ ^n5(when & (> & n4)) ~ ^n6(when & (> & n5)) ~))
(setqq ThSSM-5> (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~ ^n5(when & (< & n4)) ~ ^n6(when & (< & n5)) ~))
  ;(let ((sq (faire-liste '(random 100) 26))) (print sq) (or (f3 ThSSM-4< sq) (f3 ThSSM-5> sq)))
  ;(let ((sq (faire-liste '(random 100) 26))) (print sq) (multiple-value-bind (V vars) (f3 ThSSM-5< sq) (if V (values V vars) (f3 ThSSM-5> sq))))

;; Encore mieux !!!

(setqq ThSSM-5<> (?_(
  (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~ ^n4(when & (> & n3)) ~ ^n5(when & (> & n4)) ~ ^n6(when & (> & n5)) ~)
  (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~ ^n4(when & (< & n3)) ~ ^n5(when & (< & n4)) ~ ^n6(when & (< & n5)) ~)
)))
  ;(let ((sq (faire-liste '(random 100) 26))) (print sq) (f3 ThSSM-5<> sq))

;; <n> = 2 ---------------------

(setqq ThSSM-2< (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~))
(setqq ThSSM-2> (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~))
  ;(let ((sq (faire-liste '(random 100) 5))) (print sq) (or (f3 ThSSM-2< sq) (f3 ThSSM-2> sq)))
  ;(let ((sq (faire-liste '(random 100) 5))) (print sq) (multiple-value-bind (V vars) (f3 ThSSM-2< sq) (if V (values V vars) (f3 ThSSM-2> sq))))

;; Encore mieux !!!

(setqq ThSSM-2<> (?_(
  (~ _n1 ~ ^n2(when & (> & n1)) ~ ^n3(when & (> & n2)) ~)
  (~ _n1 ~ ^n2(when & (< & n1)) ~ ^n3(when & (< & n2)) ~)
)))
  ;(let ((sq (faire-liste '(random 100) 5))) (print sq) (f3 ThSSM-2<> sq))
  ;(let ((sq '(22 33 33 11 22))) (print sq) (f3 ThSSM-2<> sq)) = NIL (exemple)

;;; Fonctions utilises dans certains exemples ci-dessus

(defun palindro1 (pp)
  (when bugbug (dbg pp palindro1))
  (if (atom pp) (when (qqch pp) pp)
      (reverse pp)))

(defun arpege (n)
  (and (numberp n)
       (list '% (+ n 4) '% (+ n 7))))

(defun brod (n)
  (list (list "?_" nil (1+ n) (1- n))))

(defun trois (par)
  (make-list 3 :initial-element par))

(defun qqch (var)                                 ;vrifie si <var> est "quelque
  (declare (special *rien*))                      ;chose", c.--d. ni *undef* ni
  (when (not (member var                          ;valeur de  var. spc.  *rien*
                     (list '*undef* *rien*)))))

;;   Cf. ped.12
(defun faire-liste (fonction &optional (nbr 10))
  (labels ((interne () (cond
            ((= 0 nbr) ())
            (t (decf nbr)
               (cons (eval fonction) (interne))))))
    (interne)))