;===============================================================================
;;; 19.2b --> Sances automatiques de manipulations : <2>, <3>, <4> et <5>
;$$ 19.2b --> Sitzungen automatischer Manipulationen: <2>, <3>, <4> und <5>
;$$                                                                   [d..H.B.]
;++ 19.2b --> Sessions of Automatic Manipulations: <2>, <3>, <4> and <5>
;===============================================================================

;;   Sance automatique de manipulations d'<objets> : le comportement de *robot*
;; n'est pas modifi.
;;   N.B. : on part (ventuellement) de la situation de la fin de la Sance <1>
;; de manipulations, telle qu'excute  partir du fichier ped.19.2a.seance.
;$   Automatische Sitzung mit <objets>-Manipulationen: das Verhalten des
;$ *robot* wird nicht verndert.
;$   N. B.: man geht (mglicherweise) von der Lage am Ende der Sitzung <1> der
;$ Manipulationen aus, wie sie von Datei ped.19.2a.seance ausgefhrt wurden.
;+   Automatic Session of <objets> Manipulations: the behavior of *robot* is not
;+ modified.
;+   N.B.: one (eventually) starts from the situation of the end of Session <1>
;+ of Manipulations, as performed from file ped.19.2a.seance.

(format t "~3%Seance <2> : <objets> ----------------------------------------~%")
(dolist (lordre    '(

                ;Mise en situation des <objets>

                    (pose *objet7* sur  *table*)
                    (pose *objet8* sur *objet7*)
                    (pose *objet8* sur  *table*)
                    (pose *objet9* sur *objet7*)
                    (pose *objet7* sur *objet8*)
                    (pose *objet3* sur *objet7*)  ;<- diffrent aprs Sance <1>
                    (pose *objet8* sur *objet3*)
                    (pose *objet1* sur *objet8*)
                    (pose *objet2* sur  *table*)
                    (pose *objet4* sur *objet2*)
                    (pose *objet5* sur *objet4*)
                    (pose *objet6* sur *objet5*)
                    (pose *objet0* sur *objet6*)
                    (pose  *table* sur *objet7*)
                    (pose *objet4* sur *objet2*)
                    (pose *objet7* sur *objet8*)
                    (pose *objet4* sur *objet3*)

                ))
    (format t "~%~A" lordre)
    (eval lordre))

;;   Sance automatique de manipulations de <livres> : tout ce qui tait acquis
;; pour des <objets> fonctionne maintenant aussi bien pour des <livres>.
;$   Automatische Sitzung mit <livres>-Manipulationen: alle Funktionen, die
;$ fr <objets> erarbeitet wurden, funktionieren jetzt auch fr <livres>.
;+   Automatic Session of <livres> Manipulations: all functions acquired for
;+ <objets> now also work for <livres> as well.

(format t "~3%Seance <3> : <livres> ----------------------------------------~%")
(dolist (lordre    '(

                ;Mise en situation des <livres>

                    (pose *livre7* sur  *table*)
                    (pose *livre8* sur *livre7*)
                    (pose *livre8* sur  *table*)
                    (pose *livre9* sur *livre7*)
                    (pose *livre7* sur *livre8*)
                    (pose *livre3* sur *livre7*)
                    (pose *livre8* sur *livre3*)
                    (pose *livre1* sur *livre8*)
                    (pose *livre2* sur  *table*)
                    (pose *livre4* sur *livre2*)
                    (pose *livre5* sur *livre4*)
                    (pose *livre6* sur *livre5*)
                    (pose *livre0* sur *livre6*)
                    (pose  *table* sur *livre7*)
                    (pose *livre4* sur *livre2*)
                    (pose *livre7* sur *livre8*)
                    (pose *livre4* sur *livre3*)

                ))
    (format t "~%~A" lordre)
    (eval lordre))

;;   Sance automatique de manipulations de <livres> et de <plaques> : tout ce
;; qui tait acquis pour des <objets> et pour des <livres> est complt par le
;; nouveau mode de manipulation des <plaques>. 
;;   N.B. : on part de la situation de la fin de la Sance <3> ci-dessus.
;$   Automatische Sitzung mit <livres> und <plaques>-Manipulationen: Alle fr
;$ <objets> und <livres> erarbeiteten Funktionen werden durch die neuen
;$ Manipulationsarten fr <plaques> ergnzt.
;$   N. B.: man geht von der Lage am Ende der Sitzung <3> oben aus.
;+   Automatic Session of <livres> and <plaques> Manipulations: all functions
;+ acquired for <objets> and <livres> are completed by the new manipulation mode
;+ for <plaques>.
;+   N.B.: one starts from the situation of the end of Session <3> above. 

(format t "~3%Seance <4> : <livres> et <plaques> ---------------------------~%")
(dolist (lordre    '(

                ;Mise en situation des <livres> et <plaques>

                    (pose *plaqueA* sur  *livre4*)
                    (pose  *livre8* sur *plaqueA*)
                    (pose  *livre6* sur  *livre8*)
                    (pose *plaqueB* sur  *livre6*)
                    (pose  *livre5* sur *plaqueB*)
                    (pose  *livre1* sur  *livre5*)
                    (pose  *livre2* sur  *livre7*)
                    (pose  *livre9* sur  *livre2*)
                    (pose *plaqueA* sur  *livre4*)
                    (pose *plaqueA* sur   *table*)
                    (pose *plaqueB* sur   *table*)
                    (pose  *livre4* sur  *livre3*)
                    (pose *plaqueB* sur  *livre7*)
                    (pose  *livre8* sur *plaqueB*)
                    (pose *plaqueA* sur  *livre3*)

                ))
    (format t "~%~A" lordre)
    (eval lordre))

;;   Situation  la fin des manipulations :
;$   Lage nach den Manipulationen:
;+   Situation after the manipulations:
;-
;-                                                            L8
;-             o4       o7                       --A          --B
;-    o0 o1 o2 o3 o5 o6 o8 o9           L0 L1 L2 L3  L4 L5 L6 L7  L9
;-TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
;-                               
;; <objets> : Sances <1> et <2>   <livres> et <plaques> : Sances <3> et <4>
;$ <objets>: Sitzungen <1> & <2>   <livres> und <plaques>: Sitzungen <3> & <4>
;+ <objets>: Sessions <1> & <2>    <livres> and <plaques>: Sessions <3> & <4>

;;   Sance automatique de manipulations d'<objets>, de <livres> et de
;; <plaques> : *robot* est ainsi capable de manipuler indiffremment <objets>,
;; <livres> et <plaques> dans un mme environnement. 
;;   N.B. : on part de la situation de la fin de la Sance <4> ci-dessus.
;$   Automatische Sitzung mit <objets>, <livres> und <plaques> Manipulationen:
;$ *robot* kann nun gleichgltig  <objets>, <livres> und <plaques> in
;$ derselben Umgebung manipulieren.
;$   N. B.: man geht von der Situation am Ende der Sitzung <4> oben aus.
;+   Automatic Session of <objets>, <livres> and <plaques> Manipulations:
;+ *robot* is thus capable of manipulating indifferently <objets>, <livres> and
;+ <plaques> in a same environment.
;+   N.B.: one starts from the situation of the end of Session <4> above.

(format t "~3%Seance <5> : <objets>, <livres> et <plaques> melanges --------~%")
(dolist (lordre    '(

                ;Manipulations des <objets>, <livres> et <plaques>

                    (pose *plaqueA* sur  *objet4*)
                    (pose  *livre6* sur  *livre8*)
                    (pose  *livre5* sur *plaqueA*)
                    (pose  *objet5* sur  *livre6*)
                    (pose *plaqueA* sur  *objet4*)
                    (pose *plaqueA* sur  *objet5*)
                    (pose  *livre1* sur  *livre5*)
                    (pose *plaqueB* sur   *table*)
                    (pose  *livre3* sur *plaqueA*)
                    (pose  *objet9* sur  *livre2*)
                    (pose  *livre4* sur  *livre2*)
                    (pose *plaqueA* sur  *livre4*)
                    (pose  *livre5* sur *plaqueA*)
                    (pose  *objet7* sur  *objet4*)
                    (pose  *objet6* sur  *livre1*)
                    (pose *plaqueB* sur  *livre5*)
                    (pose  *livre8* sur *plaqueB*)
                    (pose  *livre1* sur  *livre8*)
                    (pose  *livre6* sur  *objet7*)

                ))
    (format t "~%~A" lordre)
    (eval lordre))

;;   Situation type  la fin des manipulations :
;$   Typische Lage nach den Maniplationen:
;+   Typical situation after the manipulations:
;-                                                                              
;-                   L1                                              
;-                   L8                                              
;-                   --B                                             
;-       L6          L5                                              
;-       o7          --A                                             
;-       o4          L4                                              
;-   L7  o3  o6  o2  L2  L0  o1  L3  o5  o9  L9  o8  o0    
;-TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT
;-
;;  <objets>, <livres> et <plaques> : Sances <1>  <5>
;$  <objets>, <livres> und <plaques>: Sitzungen <1> bis <5>
;+  <objets>, <livres> and <plaques>: Sessions <1> to <5>

;;   Procdures d'appel, pour connatre les situations des objets. La fonction
;; ou-est? est dfinie dans le fichier ped.19.2a.
;$   Prozeduren zum Anzeigen der Lage der Objekte. Die ou-est?-Funktion wurde
;$ in Datei ped.19.2a definiert.
;+   Procedures to state the situations of the objects. The ou-est? function is
;+ defined in file ped.19.2a.

(dotimes (i 10)
    (ou-est? (symbol-value (read-from-string (format nil "*objet~A*" i)))))
(dotimes (i 10)
    (ou-est? (symbol-value (read-from-string (format nil "*livre~A*" i)))))
(ou-est? *plaqueA*)
(ou-est? *plaqueB*)
(eposi)
